<?php
class Classifieds_model extends CI_Model 
{
	var $table_name="listing";
	var $primary_key="LISTING_ID";
	var $unique_field="LISTING_ID";
    var $sort_field="LISTING_ID";
	var $file_name="";
	
    function Classifieds_model()
    {
        // Call the Model constructor
        parent::__construct();
    }

	function add_new($fields,$ret_insert_id=false)
	{
		$this->db->insert($this->table_name, $fields);
		if($ret_insert_id){
		  return $this->db->insert_id();
		}
		return true;
	}
	
	function add_job_options($fields,$ret_insert_id=false)
	{
		$this->db->insert('job_options', $fields);
		if($ret_insert_id){
		  return $this->db->insert_id();
		}
		return true;
	}
	
	function job_option_exist($id)
	{
		// get the information for given id
	    $this->db->from('job_options');
		$this->db->where('LISTING_ID',$id);
		$query = $this->db->get();
		$row = $query->row(); 
		return $row;
    }
	
	function update_job_option($fields,$id)
	{
		$this->db->where('JOB_OPTION_ID', $id);
		$this->db->update('job_options', $fields);
		return true;
	}
	
	function add_event_options($fields,$ret_insert_id=false)
	{
		$this->db->insert('event_options', $fields);
		if($ret_insert_id){
		  return $this->db->insert_id();
		}
		return true;
	}
	
	function event_option_exist($id)
	{
		// get the information for given id
	    $this->db->from('event_options');
		$this->db->where('LISTING_ID',$id);
		$query = $this->db->get();
		$row = $query->row(); 
		return $row;
    }
	
	function update_event_option($fields,$id)
	{
		$this->db->where('EVENT_OPTION_ID', $id);
		$this->db->update('event_options', $fields);
		return true;
	}
	
	function add_image($fields,$ret_insert_id=false)
	{
		$this->db->insert('listing_images', $fields);
		if($ret_insert_id){
		  return $this->db->insert_id();
		}
		return true;
	}
	function add_reply($fields,$ret_insert_id=false)
	{
		$this->db->insert('reply', $fields);
		if($ret_insert_id){
		  return $this->db->insert_id();
		}
		return true;
	}
	
	function add_view_count($fields,$ret_insert_id=false)
	{
		$this->db->insert('listing_views', $fields);
		if($ret_insert_id){
		  return $this->db->insert_id();
		}
		return true;
	}
		
	function unique_exists($unique_value,$district_id,$exclude_id=-1)
	{
		$query=$this->db->query("SELECT $this->unique_field FROM $this->table_name WHERE $this->unique_field='$unique_value' AND $this->primary_key!=$exclude_id");
	   return $query->result();
	}

	function get_count($search_fields)
	{
		$count=0;
		$this->db->select("count(*) as count");
		if($search_fields)
		{
			foreach($search_fields as $val)
			{
				//$this->db->where($val);	
				$this->db->where($val);
			}
		}
		$query = $this->db->get($this->table_name);
		if ($query->num_rows() > 0)
		{
		   $row = $query->row(); 
		   $count=$row->count;
		}
		return $count;
	}

	function get($order_sql,$search_fields,$limit,$offset,$select)
	{
		$this->db->order_by($order_sql);
		//$this->db->protect_identifiers($this->table_name, FALSE);
		$this->db->select('listing.*');
		if($select)
		{
			foreach($select as $sel)
			{
			 $this->db->select($sel);
			}	
		}	
		$this->db->from($this->table_name);
		
		if($search_fields)
		{		
			foreach($search_fields as $val)
			{
				//$this->db->where($val);	
				$this->db->where($val);
			}
		}			
		$query = $this->db->get('',$limit,$offset);
		if($query->num_rows() >0)
		{
			return $query->result_array();
		}
		else
		{
			return array();
			// return a blank areray to keep the calling function happy because it expects an array
		}
	}
	
	function get_count_replies($listing_id)
	{
		$count=0;
		$this->db->select("count(*) as count");
	
		$this->db->from('reply');
		$this->db->where('reply.LISTING_ID',$listing_id);
		$this->db->join('listing','listing.LISTING_ID=reply.LISTING_ID');
		$query = $this->db->get();
		if ($query->num_rows() > 0)
		{
		   $row = $query->row(); 
		   $count=$row->count;
		}
		return $count;
	}
	
	function get_replies($order_sql,$listing_id,$limit,$offset)
	{
		$this->db->order_by($order_sql);
		//$this->db->protect_identifiers($this->table_name, FALSE);
		$this->db->select('reply.*,listing.LISTING_TITLE');
		$this->db->from('reply');
		$this->db->join('listing','listing.LISTING_ID=reply.LISTING_ID');
		$this->db->where('reply.LISTING_ID',$listing_id);
					
		$query = $this->db->get('',$limit,$offset);
		if($query->num_rows() >0)
		{
			return $query->result_array();
		}
		else
		{
			return array();
			// return a blank areray to keep the calling function happy because it expects an array
		}
	}
	
	
	function get_listings($order_sql,$search_fields,$limit,$offset)
	{
		$this->db->order_by($order_sql);
		$this->db->from($this->table_name);
		//$this->db->join('listing_images','listing.LISTING_ID=listing_images.LISTING_ID', 'left');
		if($search_fields)
		{		
			foreach($search_fields as $val)
			{
				//$this->db->where($val);	
				$this->db->where($val);
			}
		}			
		$query = $this->db->get('',$limit,$offset);
		if($query->num_rows() >0)
		{
			return $query->result_array();
		}
		else
		{
			return array();
			// return a blank areray to keep the calling function happy because it expects an array
		}
	}
	
	
	function get_by_user($id)
	{
		$this->db->order_by('LISTING_ID DESC');
		$this->db->from($this->table_name);
		//$this->db->join('listing_images','listing.LISTING_ID=listing_images.LISTING_ID', 'left');
		
		$this->db->where('USER_ID',$id);
		
				
		$query = $this->db->get();
		if($query->num_rows() >0)
		{
			return $query->result_array();
		}
		else
		{
			return array();
			// return a blank areray to keep the calling function happy because it expects an array
		}
	}
	
	
	
	

	function get_by_id($id)
	{
		// get the information for given id
	    $this->db->from($this->table_name);
		$this->db->join('users','users.USER_ID=listing.USER_ID');
		$this->db->where($this->primary_key,$id);
		$query = $this->db->get();
		$row = $query->row(); 
		return $row;
    }
	
	
	function get_view_count($id)
	{
		// get the information for given id
	    $this->db->from('listing_views');
		
		$this->db->where($this->primary_key,$id);
		$query = $this->db->get();
		$row = $query->row(); 
		return $row;
    }
	
	// gettting images of listing
	
	function get_images($id)
	{
		// get the information for given id
	    $this->db->from('listing_images');
		$this->db->where($this->primary_key,$id);
		$query = $this->db->get();
		if($query->num_rows() >0)
		{
			return $query->result_array();
		}
		else
		{
			return array();
			// return a blank areray to keep the calling function happy because it expects an array
		}
    }
	
	// get job options using the current listing id
	
	function get_job_option($id)
	{
		// get the information for given id
	    $this->db->from('job_options');
		$this->db->where($this->primary_key,$id);
		$query = $this->db->get();
		$row = $query->row(); 
		return $row;
    }
	
	// get event options using the current listing id
	
	function get_event_option($id)
	{
		// get the information for given id
	    $this->db->from('event_options');
		$this->db->where($this->primary_key,$id);
		$query = $this->db->get();
		$row = $query->row(); 
		return $row;
    }
	
	function update($fields,$id)
	{
		$this->db->where($this->primary_key, $id);
		$this->db->update($this->table_name, $fields);
		return true;
	}
	
	function update_view_count($fields,$id)
	{
		$this->db->where($this->primary_key, $id);
		$this->db->update('listing_views', $fields);
		return true;
	}
	function delete($id)
	{
		$this->db->where($this->primary_key, $id);
		$this->db->delete($this->table_name);
		return true;
	}
	
	function delete_image($id)
	{
		$this->db->where('LISTING_IMAGE', $id);
		$this->db->delete('listing_images');
		return true;
	}
	
	
	function get_all(){
	
	    $this->db->from($this->table_name);
		$query = $this->db->get();
		$result = $query->result_array(); 
		return $result;
		
	}
 	function get_options(){
	    $options=array();
		$this->db->order_by($this->sort_field);
		$this->db->select($this->primary_key);
		$this->db->select($this->unique_field);
		$this->db->from($this->table_name);
		$query = $this->db->get();
		$results=$query->result_array();
		foreach($results as $result){
		  $options[$result[$this->primary_key]]=$result[$this->unique_field];
		}
		return $options;
	}
	
	function delete_upload($fields,$id)
	{
		$this->db->where($this->primary_key, $id);
		$this->db->update($this->table_name, $fields);
		return true;
	}
	
	function get_type_options()
	{
		return array(
		             '1'=>'Sell/buy',
					 '2'=>'Offer/Need',
		             '3'=>'Other'
					 
					 
					);
					
					
	
	}
	
	function get_type_values()
	{
		return array(
		             '1'=>'Offer',
		             '2'=>'Need'
					 
					 
					);
					
					
	
	}
	
	function get_job_type_values()
	{
		return array(
		             '1'=>'Full Time',
		             '2'=>'Part Time',
					 '3'=>'Home Based'
					 
					 
					);

	}
	
	function get_salary_values()
	{
		return array(
		             '1'=>'Less than Rs. 1L',
		             '2'=>'Rs. 1L - Rs. 2L',
					 '3'=>'Rs. 2L - Rs. 5L',
					 '4'=>'Rs. 5L - Rs. 8L',
					 '5'=>'Rs. 8L - Rs. 10L',
					 '6'=>'Rs. 10L - Rs. 15L',
					 '7'=>'Rs. 15L - Rs. 25L',
					 '8'=>'More than 25L'
					 
					 
					);

	}
	
	function get_exp_values()
	{
		return array(
		             '1'=>'Less than 1 yr',
		             '2'=>'1-3 yrs',
					 '3'=>'3-5 yrs',
					 '4'=>'5-8 yrs',
					 '5'=>'8-10 yrs',
					 '6'=>'10-15 yrs',
					 '7'=>'More than yrs',
					 
					 
					 
					);

	}
	

}
?>