<?php
class Informationdesk_model extends CI_Model 
{
	var $table_name="informationdesk";
	var $primary_key="information_id";
	var $unique_field="information_id";
   	 var $sort_field="information_title";
	var $file_name="";
	
    function Informationdesk_model()
    {
        // Call the Model constructor
        parent::__construct();
    }

	function add_new($fields)
	{
		$this->db->insert($this->table_name, $fields);
		return true;
	}
	function unique_exists($unique_value,$exclude_id=-1)
	{
		$query=$this->db->query("SELECT $this->unique_field FROM $this->table_name WHERE $this->unique_field='$unique_value' AND $this->primary_key!=$exclude_id");
	   return $query->result();
	}

	function get_count($search_fields)
	{
		$count=0;
		$this->db->select("count(*) as count");
		$this->db->join('information_category','information_category.category_id= informationdesk.category_id','inner');
		//$this->db->join('resource_topic','resource_topic.resource_topic_id= informationdesk.resource_topic_id','inner');
		$this->db->where("informationdesk.status",1);  //disable now 1 
		//$this->db->where("informationcategory.informationcategory_id",3);
	    //$this->db->where('(informationdesk.status = 1 or informationdesk.status = 2 or informationdesk.status = 3)');
		if($search_fields)
		{
			foreach($search_fields as $val)
			{
				$this->db->where($val);	
			}
		}
		$query = $this->db->get($this->table_name);
		if ($query->num_rows() > 0)
		{
		   $row = $query->row(); 
		   $count=$row->count;
		}
		return $count;
	}

	function get($order_sql,$search_fields,$limit,$offset)
	{
		if($order_sql==$this->sort_field)
		{
                         $this->db->order_by('information_id','desc'); 
			$this->db->order_by($order_sql,'desc');
	    	}else
	    	{
			$this->db->order_by($order_sql);
		}
		//$this->db->order_by($order_sql);
		$this->db->select('informationdesk.*,informationdesk.publish_status as stat,information_category.*');
		$this->db->from($this->table_name);
	   	$this->db->join('information_category','information_category.category_id= informationdesk.category_id','inner');
		//$this->db->join('resource_attachment','resource_attachment.resource_detail_id=informationdesk.resource_detail_id','left');
		//$this->db->join('resource_topic','resource_topic.resource_topic_id= informationdesk.resource_topic_id','inner');
		$this->db->where("informationdesk.status",1);  //disable now 1 
		//$this->db->where("informationcategory.informationcategory_id",3);  //or articles  primary key =3 table informationcategory
	    	//$this->db->where('(informationdesk.status = 1 or informationdesk.status = 2 or informationdesk.status = 3)');
		if($search_fields)
		{		
			foreach($search_fields as $val)
			{
				$this->db->where($val);	
			}
		}			
		$query = $this->db->get('',$limit,$offset);
	//echo $this->db->last_query();
		if($query->num_rows() >0)
		{
			return $query->result_array();
		}
		else
		{
			return array();
			// return a blank areray to keep the calling function happy because it expects an array
		}
	}

	function get_by_id($id)
	{
		// get the information for given id
$this->db->select('informationdesk.*,information_category.*,information_category.category_name as category_name,information_category.category_id as category_id');
	       $this->db->from($this->table_name);
$this->db->join('information_category','information_category.category_id= informationdesk.category_id','inner');
		$this->db->where($this->primary_key,$id);
		$query = $this->db->get();
		//echo $this->db->last_query();
		$row = $query->row(); 
		return $row;
    }

	function add_new_informationdesk_track($fields,$insert_id)
	{
		$this->db->insert("informationdesk_track", $fields);
		if($insert_id){
                 return $this->db->insert_id();
                 }
		return true;
	}
	
	function update($fields,$id)
	{
		$this->db->where($this->primary_key, $id);
		$this->db->update($this->table_name, $fields);
		return true;
	}

	function get_comments_options()
	{
		return array(
		             '1'=>'Pending',
					 '2'=>'Approved',
		          
					 '3'=>'Cancelled'
					 
					);
	}
	

	function delete($id)
	{
		
		//echo"delete function</br>";

		$this->db->where($this->primary_key, $id);
		$this->db->delete($this->table_name);
		return true;
	}

	function get_by_id_informationdesk($id)//for all resource without answer too
	{
		// get the information for given id
	    $this->db->from($this->table_name);
		$this->db->where($this->primary_key,$id);
		$this->db->join('information_category','information_category.category_id= informationdesk.category_id','inner');
		//$this->db->join('resource_topic','resource_topic.resource_topic_id= resource_details.resource_topic_id','inner');
		$this->db->where("informationdesk.status",1);  //disable now 1 
	    //$this->db->where('(resource_details.status = 1 or resource_details.status = 2 or resource_details.status = 3)');
		
		$query = $this->db->get();
		//echo $this->db->last_query();
		$row = $query->row(); 
		return $row;
	}

	function get_options_publishstatus($information_id)
	{
	   // $options=array();
		//$this->db->order_by($this->scheme_amount_sort_field);
		$this->db->from($this->table_name);
		$this->db->where('informationdesk.information_id',$information_id);
	   // $this->db->where("resource_details.active_status",1); 
		//$this->db->where("resource_details.publish_status",1); 
		//$this->db->where("resource_details.status",1); 
		$query = $this->db->get();
		//$results=$query->result_array();
		//return $results;
	       // echo $this->db->last_query();
		 $row = $query->row(); 
	         return $row;
	}

	function get_status_publish($information_id,$datastatus)
	{

		
		$this->db->where($this->primary_key,$information_id);
		$this->db->update($this->table_name,$datastatus);
		
	//	echo $this->db->last_query();
		return true;
    	}
	
	
	
	function get_all(){
	
	    $this->db->from($this->table_name);
		$query = $this->db->get();
		$result = $query->result_array(); 
		return $result;
		
	}

 	function get_options(){
	    $options=array();
		$this->db->order_by($this->sort_field);
		$this->db->select($this->primary_key);
		$this->db->select($this->unique_field);
		$this->db->from($this->table_name);
		$query = $this->db->get();
		$results=$query->result_array();
		foreach($results as $result){
		  $options[$result[$this->primary_key]]=$result[$this->unique_field];
		}
		return $options;
	}
	 function get_options_viewpoint()
		{
	       $options=array();
		$this->db->order_by($this->sort_field);
		$this->db->select($this->primary_key);
		$this->db->select($this->unique_field);
		$this->db->from($this->table_name);
		$this->db->where('category.category_type' ,1);//viewpoint box type
 
		$query = $this->db->get();
		$results=$query->result_array();
		foreach($results as $result){
		  $options[$result[$this->primary_key]]=$result[$this->unique_field];
		}
		return $options;
	}

      function get_options_complaintbox()
		{
	        $options=array();
		$this->db->order_by($this->sort_field);
		$this->db->select($this->primary_key);
		$this->db->select($this->unique_field);
		$this->db->from($this->table_name);
		$this->db->where('category.category_type' ,2);//complaint box type
 
		$query = $this->db->get();
		$results=$query->result_array();
		foreach($results as $result){
		  $options[$result[$this->primary_key]]=$result[$this->unique_field];
		         }
		return $options;
	}
	function delete_upload($fields,$id)
	{
		$this->db->where($this->primary_key, $id);
		$this->db->update($this->table_name, $fields);
		return true;
	}
	
	function get_type_options()
	{
		return array(
		              '1'=>'ആന്ദ്രപ്രദേശ്',
			      '2'=>'അരുനാചല്‍ പ്രദേശ്',
			      '3'=>'ആസ്സാം',
			      '4'=>'ബീഹാര്‍',
			      '5'=>'ഛത്തീസ്ഗഡ്',
			      '6'=>'ഗോവ',
			      '7'=>'ഗുജറാത്ത്',
			      '8'=>'ഹരിയാന',
			      '9'=>'ഹിമാചല്‍ പ്രദേശ്',
			      '10'=>'ജമ്മു കശ്മിര്‍',
			      '11'=>'ഝാര്‍ഖന്ഡ്',
			      '12'=>'കര്‍ണാടകം',
			      '13'=>'കേരളം',
			      '14'=>'മധ്യപ്രദേശ്',
			      '15'=>'മഹാരാഷ്ട്ര',
			      '16'=>'മണിപുര്‍',
			      '17'=>'മേഖാലയ',
			      '18'=>'മിസോരാം',
			      '19'=>'നാഗാലാന്റ്റ്',
			      '20'=>'ഒഡിഷ',
			      '21'=>'പഞ്ചാബ്',
			      '22'=>'രാജസ്താന്‍',
			      '23'=>'സിക്കിം',
			      '24'=>'തമില്‍നാഡ്',
			      '25'=>'ത്രിപുര',
			      '26'=>'ഉത്തര്‍പ്രദേശ്',
			      '27'=>'ഉത്തരാഖന്‍ഡ്',
			      '28'=>'വെസ്റ്റ് ബെന്‍ഗ്ഗാള്‍'

		                   
		);
	
	}

/*wellme*/
// get the information for given id with public and active statue 2
function get_all_information_desk($id)
{


	        $this->db->from($this->table_name);
		$this->db->where('informationdesk.category_id',$id);
		$this->db->join('information_category','information_category.category_id= informationdesk.category_id','inner');
		$this->db->where("informationdesk.publish_status",2); 
	        $this->db->where("informationdesk.active_status",2);		
		$query = $this->db->get();
		//echo $this->db->last_query();
		$result = $query->result_array(); 
		return $result;

}

function get_details_desk($id)
{
                $this->db->from($this->table_name);
		$this->db->where('informationdesk.information_id',$id);
		$this->db->where("informationdesk.publish_status",2); 
	        $this->db->where("informationdesk.active_status",2);		
		$query = $this->db->get();
		//echo $this->db->last_query();
		$row = $query->row(); 
		return $row;
}


/**/
	

}
?>
