<?php
class Topicspanelistwise_model extends CI_Model 
{
	var $table_name="roundtable_topics";
	var $primary_key="roundtable_topic_id";
	var $unique_field="roundtable_topic";
    var $sort_field="roundtable_topic";
	//var $file_name="";
	
    function Topicspanelistwise_model()
    {
        // Call the Model constructor
        parent::__construct();
    }

	function add_new($fields,$insert_id)
	{
		$this->db->insert($this->table_name, $fields);
		if($insert_id){
                 return $this->db->insert_id();
                 }
		return true;
	}
	function unique_exists($unique_value,$exclude_id=-1)
	{
		$query=$this->db->query("SELECT $this->unique_field FROM $this->table_name WHERE $this->unique_field='$unique_value' AND $this->primary_key!=$exclude_id");
	   return $query->result();
	}

	function get_count($search_fields,$panelist_id)
	{
		$count=0;
		$this->db->select("count(*) as count");
		$this->db->join('topic_panelist_mapping','roundtable_topics.roundtable_topic_id=topic_panelist_mapping.roundtable_topic_id','inner');
		$this->db->where("topic_panelist_mapping.panelist_id",$panelist_id);
		//this->db->where("roundtable_topic",);
		
		if($search_fields)
		{
			foreach($search_fields as $val)
			{
				$this->db->where($val);	
			}
		}
		$query = $this->db->get($this->table_name);
		 
		//echo $this->db->last_query();
		if ($query->num_rows() > 0)
		{
		   $row = $query->row(); 
		   $count=$row->count;
		}
		return $count;
	}

	function get($order_sql,$panelist_id,$search_fields,$limit,$offset)
	{
		$this->db->order_by($order_sql);
		$this->db->from($this->table_name);
	
		$this->db->join('topic_panelist_mapping','roundtable_topics.roundtable_topic_id=topic_panelist_mapping.roundtable_topic_id','inner');
		$this->db->where("topic_panelist_mapping.panelist_id",$panelist_id);
		if($search_fields)
		{		
			foreach($search_fields as $val)
			{
				$this->db->where($val);	
			}
		}			
		$query = $this->db->get('',$limit,$offset);
		  //echo $this->db->last_query();
		if($query->num_rows() >0)
		{
			return $query->result_array();
		}
		else
		{
			return array();
			// return a blank areray to keep the calling function happy because it expects an array
		}
	}

	function get_by_id($id,$panelist_id)
	{
		// get the information for given id
	    $this->db->from($this->table_name);
	    
	    
		$this->db->join('topic_panelist_mapping','roundtable_topics.roundtable_topic_id=topic_panelist_mapping.roundtable_topic_id','inner');
		$this->db->where("topic_panelist_mapping.panelist_id",$panelist_id);
	   // $this->db->join('panalist_comments','roundtable_topics.roundtable_topic_id=panalist_comments.roundtable_topic_id','left');
		$this->db->where($this->primary_key,$id);
		//$this->db->where("roundtable_topic_status",2);
		$query = $this->db->get();
		
		//echo $this->db->last_query();
		$row = $query->row(); 
		return $row;
    }
	
	
	/*function check($user_login_name,$user_password)
    {
        $this->db->from('user');
		$this->db->where("user_login_name",$user_login_name);
	
		$this->db->where("user_password",$user_password);
		//echo $this->db->_compile_select() ;
		$query = $this->db->get();
	     //echo $this->db->last_query();
		return $query->row();
    }*/
    
	function update($fields,$id)
	{
		$this->db->where($this->primary_key, $id);
		$this->db->update($this->table_name, $fields);
		//echo $this->db->last_query();
		return true;
	}
	function delete($id)
	{
		$this->db->where($this->primary_key, $id);
		$this->db->delete($this->table_name);
		return true;
	}
	function delete_mapping_table($id)
	{
		$this->db->where("topicpanelist_mapping_id", $id);
		$this->db->delete("topic_panelist_mapping");
		return true;
	}
	
	function get_all($panelist_id){
	
	    $this->db->from($this->table_name);
	    
		$this->db->join('topic_panelist_mapping','roundtable_topics.roundtable_topic_id=topic_panelist_mapping.roundtable_topic_id','inner');
		$this->db->where("topic_panelist_mapping.panelist_id",$panelist_id);
	    //$this->db->join('panalist_comments','roundtable_topics.roundtable_topic_id=panalist_comments.roundtable_topic_id','left');
		$query = $this->db->get();
		//echo $this->db->last_query();
		$result = $query->result_array(); 
		return $result;
		
	}
 	function get_options(){
	    $options=array();
		$this->db->order_by($this->sort_field);
		$this->db->select($this->primary_key);
		$this->db->select($this->unique_field);
		$this->db->from($this->table_name);
		//$this->db->join('panalist_comments','roundtable_topics.roundtable_topic_id=panalist_comments.roundtable_topic_id','left');
		
		$this->db->join('topic_panelist_mapping','roundtable_topics.roundtable_topic_id=topic_panelist_mapping.roundtable_topic_id','inner');
		$this->db->where("topic_panelist_mapping.panelist_id",15);
		$query = $this->db->get();
		
		
		//echo $this->db->last_query();
		$results=$query->result_array();
		foreach($results as $result){
		  $options[$result[$this->primary_key]]=$result[$this->unique_field];
		}
		return $options;
	}
	
	function delete_upload($fields,$id)
	{
		$this->db->where($this->primary_key, $id);
		$this->db->update($this->table_name, $fields);
		return true;
	}
	
	function get_type_options()
	{
		return array(
		             '1'=>'Admin',
					 '2'=>'Moderator',
		             '3'=>'Panelist',
					 '0'=>'Nil Type'
					 
					);
	}
	function get_gender_options()
	{
		return array(
		             '1'=>'Female',
					 '2'=>'Male',
		           
					 '0'=>'Nil Gender'
					 
					);
	}
	function get_topics_options($panelist_id)
	{
		return array(
		             '1'=>'Inactive',
					 '2'=>'Active',
		           
					 '0'=>'Nil Status'
					 
					);
	}
	
	function get_priority_options()
	{
		return array(
		             '1'=>'1',
					 '2'=>'2',
		   
					 '3'=>'3',
					 '4'=>'4',
					 '5'=>'5',
		    
					 '6'=>'6',
					 '7'=>'7',
					 '8'=>'8',
		     
					 '9'=>'9',
					 '10'=>'10',
					 '11'=>'11',
		      
					 '12'=>'12',
					 '13'=>'13',
					 '14'=>'14',
		      
					 '15'=>'15',
					 '16'=>'16',
					 '17'=>'17',
		      
					 '18'=>'18',
					 '19'=>'19',
					 '20'=>'20',
				
					 '21'=>'21',
					 '22'=>'22',
					 '23'=>'23',
		      
					 '24'=>'24',
					 '25'=>'25'
					  
					);
	}
	
	
	

	
}
?>
