<?php
if ( ! class_exists('PHPMailer'))
{	
	require_once(APPPATH.'libraries/phpmailer'.EXT);		
}
if ( ! class_exists('SMTP'))
{	
	require_once(APPPATH.'libraries/smtp'.EXT);		
}

	class Form_mailer
	{
		var $message         = array();
		var $heading         = '';
		var $env_report      =false;
 		var $mail            ='';
		var $smtp_auth       =false;
		var $smtp_host       ='localhost';
		var $smtp_user       ='';
		var $smtp_pass       ='';
		var $protocol        ='smtp';
        var $word_wrap       ='50';
		var $format          =0; // 0:send all post data as html. 1:send custom html 2:send plain text.
		function Form_mailer($config=array())
		{
			$this->mail=new PHPMailer();
			if (count($config) > 0)
			{
				$this->initialize($config);
				
			}	
		}
		
		function initialize($config = array())
		{
			$this->clear();
			foreach ($config as $key => $val)
			{
				if (isset($this->$key) && $key!='mail')
				{
					$method = 'set_'.$key;
					
					if (method_exists($this, $method))
					{
						$this->$method($val);
					}
					else
					{
						$this->$key = $val;
					}			
				}
			}
		}

		function clear()
		{
		}
		
		function clearall()
		{
		   $this->mail->ClearAllRecipients();
		}

		function addAttachment($filePathName,$fileName)
		{
			$this->mail->AddAttachment($filePathName,fileName);
		}


		function send()
		{   

			$this->mail->Host =$this->smtp_host;
			//for smtp mailing
			if($this->protocol=='smtp')
			{ 
				$this->mail->IsSMTP();
				//set autentication
				if($this->smtp_auth)
				{
					$this->mail->SMTPAuth = true;
					$this->mail->Username = $this->smtp_user;
					$this->mail->Password = $this->smtp_pass;
				}
				else
				{
					$this->mail->SMTPAuth = false;
				}
			}
			//for sendmail mailing
			if($this->protocol=='sendmail'){ 
				$this->mail->IsSendmail();
			}
			//for mail mailing
			if($this->protocol=='mail'){ 
				$this->mail->IsMail();
			}
			$this->mail->WordWrap = $this->word_wrap;                  
			if(!$this->mail->Send())
			{
			   return false;
			}			
			return true;
		}

       function from($from='',$from_name='')
	   {
            //set mail from
			if($from!='')
			{ 
			   $this->mail->From =$from;
			}
			if($from_name!=''){ 
			   $this->mail->FromName =$from_name;
			}
		}

       
	    function to($to='')
		{
			//set mail to
			if(is_string($to))
			{
			 $this->mail->AddAddress($to); 
			}else{
			  foreach($to as $mail_to)
			  {
			    $this->mail->AddAddress($mail_to); 
			  }
			}  
		}
		
		function cc($cc='')
		{
			if($cc!='')
			{
				if(is_string($cc))
				{
				 $this->mail->AddCC($cc); 
				}
				else
				{
				  foreach($cc as $mail_cc)
				  {
					$this->mail->AddCC($mail_cc); 
				  }
				} 
			} 
		}
		
		function bcc($bcc)
		{
			if($bcc!='')
			{
				if(is_string($bcc))
				{
				 $this->mail->AddBCC($bcc); 
				}
				else
				{
				  foreach($bcc as $mail_bcc)
				  {
					$this->mail->AddBCC($mail_bcc); 
				  }
				} 
			} 
		}
		
		function subject($subject)
		{
			$this->mail->Subject = $subject;
		}
		
		function message($data)
		{
			if($this->format==0)
			{
			  $this->mail->IsHTML(true);  
			  $this->message=$data;  
			  $this->mail->Body    = $this->getHtmlHeaders().$this->parseForm().$this->getHtmlFooters();
			}
			else if($this->format==1)
			{
			  $this->mail->IsHTML(true);                                  
			  $this->mail->Body    = $this->getHtmlHeaders().$data.$this->getHtmlFooters();
			}
			else if($this->format==2)
			{
			  $this->mail->IsHTML(true);                                  
			  $this->mail->Body    = $data;
			}
			else if($this->format==3)
			{
			  $this->mail->IsHTML(false);                                  
			  $this->mail->Body = $data;
			}
		}
		
		function attach($file_path,$file_name='')
		{
			if(!$file_name)
			{   
				$this->mail->AddAttachment($file_path); 
			}else
			{
				$this->mail->AddAttachment($file_path,$file_name);
			}
		}
	
		function _set_format($format)
		{
		  $this->format=$format;
		}
		
		function _set_env_report($env)
		{
		  $this->env_report=$env;
		}
        
		function set_protocol($protocol='smtp')
		{
		    
			$this->protocol=$protocol;
		}

        // Allowed values are true , false
		function set_keep_alive($keep_alive=false)
		{
			$this->mail->SMTPKeepAlive=$keep_alive;
		}

		function set_smtp_auth($smtp_auth=false)
		{
			$this->mail->SMTPAuth=$smtp_auth;
		}

		function set_user_name($user_name='')
		{
			$this->mail->Username=$user_name;
		}
 
 		function set_password($password='')
		{
			$this->mail->Password=$password;
		}
		
		//return the error;
        function get_error()
		{
		   return $this->mail->ErrorInfo;
		}

        function smtp_close()
		{
		   $this->mail->SmtpClose();;
		}

        function clear_addresses()
		{
		   $this->mail->ClearAddresses();;
		}
  
        function clear_attachments()
		{
		   $this->mail->ClearAttachments();;
		}

        function clear_ccs()
		{
		   $this->mail->ClearCCs();;
		}

        function clear_bccs()
		{
		   $this->mail->ClearBCCs();;
		}

		function heading($head)
		{
			$this->mail->heading = $head;
		}

		function parseForm()
		{
			$table_data="";
			$http = array(
							'REMOTE_ADDR'			=> $_SERVER['REMOTE_ADDR'],
							'HTTP_USER_AGENT'		=> $_SERVER['HTTP_USER_AGENT']
						  );
			$date=date('D-F-Y g:i:s T');
			if ($this->format==0)
			{
				$table_data.="<table>";
				if($this->heading!='')
				{
				  $table_data.="<tr><td align='center' colspan=2 class='headingCol'>".$this->heading."</td></tr>";
				}
				foreach ($this->message as $key => $value) 
				{   
				    $post_data=isset($_POST[$key])?$_POST[$key]:'&nbsp;';
					if (is_array($post_data))
					{
						
						$post_data=implode(",",$post_data);
					}
					$table_data.="<tr><td class='descriptionHeader'>".$value."</td><td class='description'>".$post_data ."</td></tr>";
					
				}
				
				if ($this->env_report)
				{
					$table_data.="<tr><td align='center' colspan=2 class='headingRow'>User Environment</td></tr>";
					foreach ($http as $key => $value) 
					{
							$table_data.="<tr><td class='descriptionHeader'>".$key."</td><td class='description'>".$value ."</td></tr>";
					}
					$table_data.="<tr><td class='descriptionHeader'>Date:</td><td class='description'>".$date ."</td></tr>";
				}
				$table_data.="</table>";
			}
			return $table_data;
		}

		function getHtmlHeaders()
		{
			$htmlCode= <<< HTMLCODE
				<html>
					<head>
					<title>--</title>
					<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
					<style type="text/css">
					<!--
					 body
					{
						color : #000000;
						font-family : Tahoma, Verdana, Arial;
						font-weight: bold;
					}

					.headingCol
					{
						color : #FFFFFF;
						font-family : Tahoma, Verdana, Arial;
						font-weight: bold;
						background-color: #0065B3;
					} 
					.descriptionHeader
					{
						color : #FFFFFF;
						font-family : Tahoma, Verdana, Arial;
						font-weight: bold;
						background-color: #0065B3;
						width:50%;
					}
					.description
					{
						color : #000000;
						font-family : Tahoma,Verdana,Arial;
						font-weight: bold;
						background-color: #D8E6F3;
						width:50%;
					}

					-->
					</style>
					</head>
					<body>
HTMLCODE;
					return $htmlCode;
		}
		function getHtmlFooters()
		{
				$htmlCode= <<< HTMLCODE
					</body>
					</html>
HTMLCODE;
			return $htmlCode;
		}
	}
?>
